/* Demo of the SRE-Data addon for SRE-http.  This can be used
either to look at or launch an SRE-Data daemon.

If used to look at a database, you must
first launch a SRE-data daemon, such as with the following os/2 command:
   sredata name=fip prog=sredata\fipsname.in

or by calling this from the form in SREDATA.HTM!

*/


/* get the list of values sent from SRE-http, or bbscache.cmd */
parse arg  ddir, tempfile, reqstrg,list0,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir

if upper(verb)="GET" then parse var uri . '?' list0

location_only=0; nth=1 ; varname=0 ; qname='INDEX';dowait=0;dokill=0
dolaunch=0
filename="" ; type=""
do until list0=""
   parse var list0 v1 '&' list0
   parse var v1 avar '=' aval ; avar=strip(upper(avar)); aval=packur(translate(aval,' ','+'))
   if avar="TARGET" then atarget=aval
   if avar="VARNAME" then varname=aval
   if avar="NAME"  then qname=aval
   if avar="NTH" then nth=aval
   if avar="LOCATION_ONLY" then location_only=aval
   if abbrev(avar,'LAUNCH')=1 then dolaunch=aval
   if abbrev(avar,'FILE')=1 then filename=aval
   if abbrev(avar,'STR')=1 then astring=aval
   if avar='TYPE' then type=upper(aval)
   if avar='WAIT_STATUS' then dowait=1
   if avar="KILL_DAEMON" then dokill=1
end /* do */


/* kill a daemon */
if dokill=1 then do
   okay=add_findindex()
   call lineout tempfile, "<body><h2>Killing a SRE-Data daemon</h2>"
   call lineout tempfile, "<html><head><title>Kill a Daemon Results</title></head>"
   yow0=sref_find_index(targ,'*DIE*'||qname)
   parse var yow0 yow','amess
   if yow<>-3 then do
      call lineout tempfile,' ERROR: Problem closing data daemon: <tt>'yow0 '</tt>'
       call lineout tempfile, "</body></html>"
       call lineout tempfile
      return 'FILE ERASE TYPE text/html NAME ' tempfile
   end  /* Do */
   else
   usequeue='SRED_'||qname
   usesem='\sem32\SRED_'||qname
   foo1=eventsem_reset(usesem)
   foo1=eventsem_close(usesem)
   foo2=rxqueue('D',usequeue)

   call lineout tempfile,'The <b> ' qname'</b> SRE-Data daemon has been killed'
   if foo1<>0 then call lineout tempfile,' <BR><B>Warning:</b>problem closing daemons semaphore:'foo1
   if foo2<>0 then call lineout tempfile,' <BR><B>Warning:</b>problem closing daemons queue:'foo2
   call lineout tempfile, "</body></html>"
   call lineout tempfile
  return 'FILE ERASE TYPE text/html NAME ' tempfile
end  /* Do */

/* IF launcher, do launch it and go away (or query ?obs if dowait=1*/
if dolaunch=1 then do
   okay=add_findindex()
   call lineout tempfile, "<html><head><title>DATADEMO Results</title></head>"
   call lineout tempfile, "<body><h2>Launching an SRE-Data daemon</h2>"
   if okay=0 then do then
      call lineout tempfile,' <B> ERROR</b>: could not find/load SREF_FIND_INDEX '
      dowait=0          /* don't wait */
   end  /* Do */
   else do              /* sref_find_index is available, so load the daemon */
      ff=launchit()

      if ff=0  then dowait=0
   end
   if dowait=0 then do          /* dont' wait for end of daemon initilizaiton */
      call lineout tempfile, "</body></html>"
      call lineout tempfile
      return 'FILE ERASE TYPE text/html NAME ' tempfile
   end

/* else, wait for daemon to give status info */
    call syssleep(1)   /* give daemon a chance ... */
    foo=sref_find_index('',qname,'!OBS')
    parse var foo astat','amess
    if foo<0 then do
        call lineout tempfile,' <B>ERROR in Daemon: ('astat'):'amess
        call lineout tempfile
        return 'FILE ERASE TYPE text/html NAME ' tempfile
    end  /* Do */
    foo2=sref_find_index('',qname,'!COMMENT')
    parse var foo2 .','acomm
    call lineout tempfile,'<br><b>Comment:</b>'acomm '<br>'
    call lineout tempfile,'<b>Number of observations</b>= 'astat ', <b>number of variables</b>='amess
    call lineout tempfile
    return 'FILE ERASE TYPE text/html NAME ' tempfile
end  /* Do */

/* else, it's a "view data call" */


call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
call lineout tempfile, "<html><head><title>DATADEMO Results</title></head>"
call lineout tempfile, "<body><h2>DATADEMO results</h2>"


if macroquery('sref_find_index')='' then do
    call lineout tempfile,' Sorry, SREF_FIND_INDEX not avaiable. <br>'
    call lineout tempfile,' Did you "launch" the SRE-Data daemon? '
    call lineout tempfile, "</body></html>"
    call lineout tempfile  /* close */
   return 'FILE ERASE TYPE text/html NAME ' tempfile
end  /* Do */

yow=sref_find_index(atarget,qname,varname,nth,location_only)
  call lineout tempfile,' You requested:<ul> '
  call lineout tempfile,'<li><B>Name (database handle)</b>:'qname
  call lineout tempfile,'<li><B>Target</b>:'atarget
  call lineout tempfile,'<li><B>VarName</b>:'varname
  call lineout tempfile,'<li><B>Nth</b>:'nth
  call lineout tempfile,'<li><B>Location_only</b>:'location_only
 call lineout tempfile,'</ul>'

parse var yow rnum ',' avalue

/* some error codes:
-1 bad record number/no semaphore/bad return
-3 daemon killed
-4 bad semaphore
-5 sem query error
*/

  call lineout tempfile,'<h3>The results</h3>'
  if rnum<0 then do
      call lineout tempfile,' <b>Error</b>: <tt> ' yow '</tt>'
  end  /* Do */
  else do
    if rnum=0 then do
         call lineout tempfile,' <B>No Match </b>'
    end  /* Do */
    else do
       call lineout tempfile,' <B> Record Number: </b>' rnum
       call lineout tempfile,' <br><b> Value:</b><tt>'avalue'</tt>'
    end
  end

  call lineout tempfile, "</body></html>"
  call lineout tempfile  /* close */
  return 'FILE ERASE TYPE text/html NAME ' tempfile



/**************************************/
/* sredata launcher */
launchit:procedure expose type filename astring tempfile qname


/* check for mess ups */
if wordpos(type,'DATA PROG KEY STEM LOADKEY STRING')=0 then do
     call lineout tempfile,' <b>ERROR</b>: Unknown type: 'type
     return 0
end  /* Do */
if type='STRING' &  astring="" then do
     call lineout tempfile,' <b>ERROR</b>: String type, but no "program string" available '
     return 0
end
signal on error name ln1 ; signal on syntax name ln1
if type='STRING' then 
  status=sredata.cmd(qname,type,astring)
else
   status=sredata.cmd(qname,type,filename)

parse var status status amess
if status=0 then
   call lineout tempfile,' Error: could not launch the daemon:<tt>' amess'</tt>'
else
  call lineout tempfile,' The daemon for 'qname' has been launched.'
return status

ln1:
signal off error ;signal off syntax
call lineout tempfile,' <b>ERROR</b>: Probably could not find SREDATA.CMD '
return 0


/********/
add_findindex:procedure
if macroquery('SREF_FIND_INDEX')<>'' then return 1

foo=macroadd('SREF_FIND_INDEX','SREDATA.SRF','b')
if foo=0 then  return 0


/************/
/* SREF_MKPACK64   :  string_packed_64=sref_mkpack64(astring)

Takes a single string and converts into a MIME "Base64" string
(using in RFC 1521).
This is the inverse of SREF_PACK64 (and of the goserve pack64 function)
************/
/* create a base64 packing of a message */
mk_pack64:procedure

do mm=0 to 25           /* set base 64 encoding keys */
   a.mm=d2c(65+mm)
end /* do */
do mm=26 to 51
   a.mm=d2c(97+mm-26)
end /* do */
do mm=52 to 61
   a.mm=d2c(48+mm-52)
end /* do */
a.62='+'
a.63='/'

parse arg mess
s2=x2b(c2x(mess))
ith=0
do forever
   ith=ith+1
   a1=substr(s2,1,6,0)
   ms.ith=x2d(b2x(a1))
   if length(s2)<7 then leave
   s2=substr(s2,7)
end /* do */
pint=""
do kk=1 to ith
    oi=ms.kk ; pint=pint||a.oi
end /* do */
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint




/************/
/* rd_pack64   :  astring=SREF_pack64(string_packed_64)

Takes a single string, expressed according to the MIME "Base64"
specification (in RFC 1521), as an argument and returns the decoded
(packed) string.  Each four bytes in 'string' is packed to three bytes
in the result (except possibly for the last four bytes); 'string' must
be a multiple of 4 bytes.  If any deviation from these specifications
(or from the RFC 1521 "Base64" character set) is found, the null string
is returned.
This is the EXACT SAME THING as goserve's pack64 function)
*/

rd_pack64:procedure
do mm=0 to 25           /* set base 64 encoding keys */
   a.mm=d2c(65+mm)
end /* do */
do mm=26 to 51
   a.mm=d2c(97+mm-26)
end /* do */
do mm=52 to 61
   a.mm=d2c(48+mm-52)
end /* do */
a.62='+'
a.63='/'

parse arg mess
newmess=""
do mm=1 to length(mess)
   a1=substr(mess,mm,1)
   a1a=c2d(a1)
   select
     when a1a>64 & a1a<91  then a1b=a1a-65  /* ascii 65 to 90 */
     when a1a>96 & a1a<123 then a1b=26+(a1a-97)  /* ascii 97 to 122 */
     when a1a>47 & a1a<58  then a1b=a1a+4   /* ascii 48 to 57 */
     when a1='+' then a1b=62
     when a1='/' then a1b=63
     when a1='=' then iterate
     otherwise return ""        /* error */
   end
   pp=x2b(d2x(a1b))
   if length(pp)>6 then
        pp=substr(pp,3)
  else
        pp=right(pp,6,0)
   newmess=newmess||pp
end
ilen=trunc(length(newmess)/8)*8 ; newmess=left(newmess,ilen)
newm=x2c(b2x(newmess))
return newm


goter:
signal off syntax
signal off error
return '-6 Problem in SREF_FIND_INDEX (probably unavailable semaphore/queue' sigl

