/* */

call loadup
cls

say bold"SRE-DATA demo -- Search INITFILT.80. "normal
say
say " To use this, you should first enter the following from an OS/2 prompt:"
say "     "bold"D:\GOSERVE>"normal"sredata prog=sredata\initfilt.in name=initfilt"
say " where D:\GOSERVE is your GoServe working directory, and SREDATA "
say " is where you installed the SREDATA demo files"
say
say " Hint: to see intermediate results, you should run PMPRINTF. "

aname='INITFILT'



do forever
vname="" ; irec=1

   say bold" Enter string, in initfilt.80, to look for? "normal
   call charout, "  "reverse"(ENTER to exit, HELP for help):"normal
   parse pull targ ;say
   if targ="" then exit
   if translate(targ)="HELP" then do
       say " Enter a string to search for.  "
       say "  (identifier variable is the parameter name: such as VERBOSE or CHECK_ALIAS)"
       say " If you search against a variable (see next step), you can use * as a wildcard "
       say " If you want to lookup an absolute record, enter the record number here."
       say " To kill the INITFILT SREDATA thread, enter *DIE* "
       iterate
   end  /* Do */

if targ='*DIE*' then do         /* tell daemon to die */
   irec=0
end  /* Do */

if irec<>0 then do
do forever
   call charout," "bold"Which variable? "normal||reverse" (ENTER=search identifiers, HELP for help):"normal 
   call charout " ? ";pull vname; say
   if translate(vname)="HELP" then do
        say " * There are two kinds of searches: "
        say "      1) Against the identifier -- much faster, wildcards NOT supported"
        say "         For this database, the identifier is the parameter_name. "
        say "      2) Against Variables -- slower, wildcards ARE supported "
        say " * In addition to the default (the identifier), this dataset contains: "
       yow2=sref_find_index(,Aname,'?')
        parse  var yow2 nv','vs
        say "   "nv" variables: " vs
        if pos('*',vs)>0 then say '    Note: * means "the entire record" '
        say " There are also a number of values that are treated as special commands "
        say "  These include: "
        say "     #: Get record #                      ?: Variable Info"
        say "     !OBS: # observations             !TYPE: type datafile"
        say "     !COMMENT: Header comment         !DATE: creation date"
        say "     !DATAFILE:original file      !PROGFILE: Original program file "
        say "     !STARTED: invoking string   "
        say ; iterate
   end  /* Do */
   leave
end   /* forever */
end  /* irec >0 */

if vname<>" " then do
     do forever
     say " Enter match# (ENTER=first,HELP for help) :"
     pull nmatch
     if translate(nmatch)="HELP" then do
        say ' When searching against "variables", it is possible to have multiple'
        say ' matches (especially if you are using  * as a wildcard). You can '
        say ' choose which match to display. '
        say  ' For example; a value of 2 means "display the second match" '
        say  ' There are also a few special codes: '
        say '     F = First match (same as 1, and same as ENTER)'
        say '     L = Last match '
        say '     C = count of matches (just the count, no value is returned) '
        say
        iterate
     end  /* Do */
     leave
     end
 end


if irec=0 then do
     aname='*DIE*INITFILT'
end  /* Do */

say " Calling sref_find_index with: " targ ',' aname
yow=sref_find_index(targ,Aname,vname,nmatch,location_only)


parse var yow  inum','aval
say
say " Matching record (0=no match, <0=Error): " inum
say " with a value of: " aval

say

end

exit


loadup:

/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
end


ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  output will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls


return




/***************/

 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC

