/* Demo program for the SRE-Data addon for SRE-http.
   Before running this for the first time, you should enter the following
   from an os/2 prompt (at the goserve working directory):
          sredata prog=sredata\fipsname.in name=fip
   After that, just enter DEM2SRED from an os/2 prompt. You will be prompted
   for options.
 */

call loadup     /* load libraries if need be */



say bold"SRE-DATA demo -- Search a county-names database. "normal
say
say " To use this, you should first enter the following from an OS/2 prompt:"
say "     "bold"D:\GOSERVE>"normal"sredata prog=sredata\fipsname.in name=fip"
say " where D:\GOSERVE is your GoServe working directory, and SREDATA "
say " is where you installed the SREDATA demo files"
say


aname='FIP'

do forever

   say " Enter string, in fipsname.dat, to look for "

   call charout, "  "reverse"(ENTER to exit, HELP for help)"normal
   parse pull targ ;say
   if targ="" then exit
   if translate(targ)="HELP" then do
       say bold" Enter a string to search for. "normal
       say "  (note: the identifier variable is county name: such as SUFFOLK or BUTLER) "
       say ' If you search against a variable (see next step), you can use * as a wildcard.'
       say " If you want to lookup an absolute record number, enter the record number here."
       iterate
   end  /* Do */

  do forever
     say ' Which variable (to "search against")?'
     call charout,"     "reverse"(ENTER=search the identifiers, HELP for help):"normal
     call charout " ? ";pull vname; say
     if translate(vname)="HELP" then do
        say " * There are two kinds of searches: "
        say "      1) Against the "bold"identifier"normal" -- much faster, wildcards NOT supported"
        say "         For this database, the identifier is the county name "
        say "      2) Against "bold"variables"normal" -- slower, * as wildcards is supported "
        say " * In addition to the default (the identifier), this dataset contains: "
        yow2=sref_find_index(,Aname,'?')
        parse  var yow2 nv','vs
        say "   "nv" variables: " vs
        if pos('*',vs)>0 then say "    Note: the "bold"*"normal" variable means "bold"the entire record"normal
        say "  You can also specify several commands "
        say "  These include: "
        say "     #: Lookup absolute record #          ?: Info on Variables"
        say "     !OBS: # observations             !TYPE: type of datafile"
        say "     !COMMENT: Header comment         !DATE: creation date"
        say "     !DATAFILE:original file      !PROGFILE: Original program file "
        say "     !STARTED: invoking string   "
        say ; iterate
     end  /* Do */
     leave
  end

  do forever
     call charout, " Enter match# "reverse"(ENTER=first found,HELP for help)"normal":"
     pull nmatch
     if translate(nmatch)="HELP" then do
        say ' If your identifir, or variable, it is possible to have multiple'
        say ' matches (especially if you are using  * as a wildcard in variable'
        say ' searches). You can  choose which match to display. '
        say  ' For example; a value of 2 means "display the second match" '
        say  ' There are also a few special codes: '
        say '    default= First found match (identifier search might return a first '
        say '             found  that is in the middle of several identical entries) '
        say '     F = First match (same as 1, and same as ENTER)'
        say '     L = Last match '
        say '     C = count of matches (just the count, no value is returned) '
        say
        iterate
    end  /* Do */
    leave
  end


if irec=0 then do               /* tell daemon to die */
     aname='*DIE*fip'
end  /* Do */


say " Calling sref_find_index  with : " targ ',' aname ',' vname
location_only=0
yow=sref_find_index(targ,Aname,vname,nmatch,location_only)
parse var yow inum','aval
say
select
   when inum=0 then say " No match. "
   when inum<0 then say " ERROR: code # "inum
   otherwise do
      say " Matching record #: " inum
      say " with a value of: " aval
   end
end
say

end  /* do forever */
exit


/*---   Load REXX libraries, etc. ----- */
loadup:
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'

  call SysLoadFuncs
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end


ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  output will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls


return




/***************/

 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC


