c sort an index, stored in an unformatted file.
c Call as SORT1  INFILE inoffset OUTFILE NRECS RECSIZE start length SORTTYPE offset quiet
c INFILE and OUTFILE-- fuly qualified file names
c inoffset === offset in the input file (# LINES OR # RECORDS
c nrecs = integer: # records (or 0- program determines)
c recsize -- size of record, in bytes
c sorttype:N=numeric or binary, C=case sensitive, I=case insensitive
c start : word to sort on , or starting character
c length:  length of string (if 0, then use word)
c offset:  characters to leave blank at top of file 
c if no arguments, program will ask

        character *60 a1(800000)
c,anow,inname,outname
        character *240 a2(200000),anow,inname,outname
        real *8 x(800000)
        character *250 tmp,tmp2
        character *1 P(4),aa1
        CHARACTER *4 FAKNUM
        character *20 kap,kap2,cmtc
        character *132 incmd
        integer fgetcmd,offset
        character *60 bs(100)
        character *240 bs2(100)

        integer indx(800000)
        logical quiet,qlarge

        common /stuff/inname,outname,inoffset,irecs,ksize,klength,
     1                kstart,kap,offset,qlarge


        offset=-2
        quiet=.false.
        inoffset=0
        qlarge=.true.

        islen=fgetcmd(incmd)
        if (incmd.eq.' ')islen=0

 22     CONTINUE

        if (islen.eq.0) then            !no info on input line

            call get_info


c READ FROM COMMAND LINE 
        ELSE                           ! READ FROM COMMAND LINE
           CALL STRIP(INCMD)
           IF (INCMD(1:1).EQ.'?') THEN 
               call show_help(incmd)
               stop
           endif

c options from command line:
           call get_info_cmd(incmd)
        endif

c further parameter checks
        if (kstart+klength.gt.250) then
           print *,' Maximum record length =250 bytes ',kstart,klength
           stop
        endif

c parameters gotten, now read input file  
        if (irecs.eq.0)  irecs=10000000

        if (ksize.gt.0) then            !open as fixed record length
          open(21,file=inname,action='read',access='direct',recl=ksize,
     1        err=800)
        else
          open(21,file=inname,err=800)          !crlf delimited records
        endif

c READY to start reading data file .....

c note: irecs=0 means "exit via eof condition "
        imax=0
        mm2=0

c find "comment line characters" list?
        cmtc=';'
        kap2=kap
        call captaliz(kap2)
        ivv=index(kap2,'D')
        if (ivv.gt.0) then
            cmtc=kap(ivv+1:lentrim(kap))
            if (ivv.gt.1) then
               kap=kap(1:ivv-1)
            else
               kap=' '
           endif
        endif
        call captaliz(kap)

C IS IS LARGE 
        ilarge=index(kap,'M')
        if (ilarge.gt.0) then 
           print *,' Many records (60 bytes, 800k max)'
           qlarge=.false.
        endif

c is it numeric
        itt=index(kap,'N')
        if (itt.gt.0) qlarge=.false.   !no large numeric identifiers


c line offset?
        if (ksize.eq.0 .and. inoffset.gt.0 ) then
                do nza=1,inoffset
                     read(21,121)aa1
                enddo
        endif

C READ THE DATA
        do mm=1,irecs
           tmp2=' '
           if (ksize.gt.0) then 
          read(21,rec=mm+(KSIZE*inoffset),end=500,err=800)tmp2(1:ksize)
           else
              read(21,121,end=500,err=2800)tmp2
              nthchar=0
              CALL STRIP(TMP2)
              IF (index(cmtc,TMP2(1:1)).gt.0) THEN  !1st char is one of the comment line chars
                    cycle                    
              endif
 121          format(a)
           endif
c pull id var from the input line
           if (kstart.ne.0.and.klength.ne.0) then       !byte reads
               tmp=tmp2(kstart:kstart+klength-1)
           else                                 !word read
              if (kstart.eq.0) then             !whole record read
                 tmp=tmp2
              else
                 call parstrg2(tmp2,bs2,100)
                 tmp=bs2(kstart)  
              endif
              imax=max0(lentrim(tmp),imax)
           endif                       !kstart=0,klength>0 is ignored
           mm2=mm2+1
           if (mm2.gt.800000) then
                print *,' ERROR. Too many observations. '
                stop
           endif
           IF (MM2.GT.2000000 .AND. QLARGE) THEN 
                print *,' ERROR. Too many observations. '
                stop
           endif
         
           if (qlarge) then
              a2(mm2)=tmp
           else
              a1(mm2)=tmp
           endif
        

           if (.not.quiet.and.mod(mm,10000).eq.1) print *,
     1           ' ... reading record # ',mm
        enddo

 500    continue
        irecs=mm2               !actual records written 

c capitalize everything?
        ikap=index(kap,'I')
        istrip=index(kap,'S')
        if (ikap+istrip.gt.0) then
           print *,' capitalizing/stripping.... '
           do mm=1,irecs
              if (ikap.gt.0) then
                 if (qlarge) then
                    call captaliz(a2(mm))
                 else
                    call captaliz(a1(mm))
                 endif
              endif
              if (istrip.gt.0) call strip(a1(mm))
            enddo
        endif

c set record size using "maximum observed word size"
       I60=60
       IF (QLARGE)I60=240
       if (klength.eq.0)klength=min(imax,I60)
       if (.not.quiet)
     1      print *,' Maximum size of identifier variable=',klength

c open output file
       if (offset.gt.0) then
           open(22,file=outname,action='readwrite',access='direct',
     1       recl=offset,err=1100)
            aa1=' '
            write(22,rec=1)aa1
           close(unit=22)
        endif

        if (offset.ge.0) then
            open(22,file=outname,action='readwrite',recordtype='fixed',
     1       recl=klength+4,err=1100,access='append')
        else
            open(22,file=outname,action='write')
        endif
 

c Now .. do the sort (lexical or straight up )
        if (.not.quiet.and.mm.ne.irecs)print *, 
     1     ' Sorting ... # records =',mm2
        if (index(kap,'N').gt.0) then            !numeric
            call nindexsort(a1,x,indx,irecs)
        else                
           if (qlarge) then 
              call indexsortb(a2,indx,irecs)
           else
              call indexsort(a1,indx,irecs)
           endif

        endif

        if (.not.quiet) print *, 'Sort completed '

        do mm=1,irecs
          JMM=INDX(MM)
          if (qlarge) then
            anow=a2(JMM)
          else
            anow=a1(JMM)
          endif
C SHIFT TO BE RIGHT JUSTIFIED
          WRITE(FAKNUM)JMM
          DO JJ=1,4
             P(5-JJ)=FAKNUM(JJ:JJ)
          ENDDO
 
          select case (offset)
             case(-2)           !just value to output file
                write(22,298)anow(1:klength)
             case(-1)           !recnum and value
                write(22,299)jmm,anow(1:klength)
             case default
                write(22,297,err=1000)P,anow(1:klength)
          end select
 297      format(4a1,a)
 298       format(a)
 299       format(i10,1x,a)
          if (.not.quiet.and.mod(mm,10000).eq.1) print *,
     1               ' writing sorted record # ',mm
        enddo

        if (offset.le.0) then
                print *,'ok'
                stop
        endif

c add stuff into offset SPACE OF OUTPUT FILE
        close(unit=22,err=1300)
        open(22,file=outname,action='readwrite',
     1          access='direct',recl=offset,
     1        err=8007,status='old')
        write(tmp,901)irecs,klength
        write(22,rec=1)tmp(1:min(offset,20))
 901    format(i10,1x,i8,' ')
        close(unit=22,err=1300)

        print *,'ok'
        stop


C ------ ERROR MESSAGES
 800    print *,' No such file: ',inname
        stop


 2800   print *,' Bad sequential read ',inname
        stop

 1000   print *,' Error writing to: ',outname
        stop
 1100   print *,' Error opening: ',outname
        stop

 1300   print *,' Error closing ',outname
        stop

 8007   print *,' error opening for writing offset info '
        stop 

        end


c==================
c show help and description
        subroutine show_help(aa)
        character *(*)aa
        character *1 a1
        logical dostop
        dostop=.true.

        if (aa(1:2).eq.'??') dostop=.false.



         WRITE(6,  100)
  100 FORMAT(
     1 ' 10 Oct. 1997.    QSORT: Indexed Quick Sort of a Flat File un',
     1                     'der OS/2'//
     1 ' Calling syntax:'/
     1 '   QSORT infile outfile inoffset nrecs recsize start length m',
     1                     'type outoff quiet'//)

        if (dostop) then
           write(6,66)
 66        format('   Hit ENTER to continue, X to exit: ',$)
           read(5,11)a1
           call captaliz(a1)
 11        format(a1)
           if (a1.eq.'X') stop
        endif

        write(6,98)
 98     format(
     1  /
     1 '                             SUMMARY '/
     1  /
     1 ' QSORT is a 32 bit OS/2 program that will extract "identifier',
     1                     's" from a'/
     1 ' flat file, sort them, and write the results to a new file. Q',
     1                     'SORT is'/
     1 ' quite fast; for example, on a 100mhz 486, 60,000 five-byte r',
     1                     'ecords'/
     1 ' are read, sorted, and written in about 20 seconds. '/
     1  /
     1 ' QSORT is an "indexed sort" -- not only does it sort, but it ',
     1                     'retains')


         WRITE(6,  102)
  102 FORMAT(
     1 ' the original positions of the sorted elements.  Thus, the ou',
     1                     'tput of'/
     1 ' QSORT can be used as index to some large set of data;  one c',
     1                     'an search such'/
     1 ' an index for some target "identifier", and uses the associat',
     1                     'ed record number'/
     1 ' as pointer into other datasets. '/
     1  /
     1 ' The flat files that QSORT works with can be structured as a ',
     1                     'text file'/
     1 ' (with one record per line), or as a file containing fixed-si',
     1                     'ze records.'/
     1 ' Data in these files can be text, numeric, or binary.  QSORT ',
     1                     'has'/
     1 ' several input format parameters that allow you to specify th',
     1                     'e location'/
     1 ' of the "identifier variable" either by using a specific char',
     1                     'acter'/
     1 ' range, or a specific "word". '/)


         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif


         WRITE(6,  104)

  104 FORMAT(
     1 ' QSORT has two types of output: fixed length records or text ',
     1                     'files.'/
     1 ' Fixed length records are well adapted for use as a quickly s',
     1                     'earched'/
     1 ' index file, but may be somewhat difficult to read with the h',
     1                     'uman eye.'/
     1 ' Text files are easier to look at, but not as convenient to w',
     1                     'ork with.'//
     1 ' HINT: To create a printable/editable copy of this HELP listi',
     1                     'ng, enter'/
     1 '            QSORT ?? > filename.xxx ')


         WRITE(6,  106)
  106 FORMAT(
     1 '       at the OS/2 prompt (of course, you can enter any filen',
     1                     'ame you want'/
     1 '       after the > ). '//)

         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif


        write(6,1061)
 1061   format(
     1 '                         CALLING Syntax '/
     1  /
     1 ' QSORT can be called with or without arguments. '/
     1  /
     1 '   * When called without arguments, the user will be "tersely',
     1                     '" prompted'/
     1 '     for several parameters. ')

         WRITE(6,  108)
  108 FORMAT(
     1 '   * To call with arguments, the following syntax should be u',
     1                     'sed:'/
     1  /
     1 '   QSORT infile outfile inoffset nrecs recsize start length m',
     1                     'type outoff quiet'//
     1 '   Hint: if you want to use QSORT as a replacement for ',
     1          'the OS/2 '/
     1 '         OS/2 sort utility (which has a 64k limit),',
     1   ' you can use: '/
     1 '             QSORT INFILE OUTFILE   '/
     1 '         This will do a line-by-line sort of INFILE, and write '
     1          'to OUTFILE.'/)


         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif

        write(6,1081)
 1081   format(/
     1 /' The following describes QSORT`s arguments. INFILE and ',
     1    'OUTFILE'/
     1  '  are required, the rest will be assigned default values '
     1  ' (if not specified).'/
     1  /
     1 '   INFILE : The "flat" file to be sorted '/
     1 '  OUTFILE : File to be created (it will contain the sorted re',
     1                     'sults)'/
     1  /
     1 '   RECSIZE: Record size, in bytes. Use a RECSIZE of 0 if INFI',
     1                     'LE is a')


         WRITE(6,  110)
  110 FORMAT(
     1 '            text file (with one record per line, lines that e',
     1                     'nd in CR-LF).'/
     1  /
     1 '     NREC:  # of records in the file. If you don`t know, ente',
     1                     'r 0'/
     1 '            and the program will determine. '/
     1  /
     1 '   INOFF  : Input file offset. Portions of the file before th',
     1                     'is offset'/
     1 '            are discarded. '/
     1 '            If you specify a non-zero RECSIZE, INOFF is '/
     1 '            interpreted as a # of records. '/
     1 '            If you specify a text (one record per line) file,',
     1                     ' this is'/
     1 '            intepreted as the number of lines to skip '/
     1 '            Note: the default value is: zero offset '/)
   


         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif



         WRITE(6,  114)
  114 FORMAT(
     1 '    START:  Starting location  and length of the identifier v',
     1                     'ariable.'/
     1 '   LENGTH:  Note that START and LENGTH are considered togethe',
     1                     'r, and can'/
     1 '            have special meanings: '//
     1 '            *  START=0, LENGTH=0  : Use the entire record (i.',
     1                     'e.; do'/
     1 '                not identify a particular part of it to sort o',
     1                     'n).'//
     1 '            *  START=n, LENGTH=0; n>0 : Use the n`th "word", ',
     1                     'where'/
     1 '               words are delimited by spaces and commas. '/
     1  /
     1 '            *  START=n, LENGTH=m; n and m > 0.  START is '/
     1 '               the n`th byte in the record, and LENGTH signif',
     1                     'ies that the'/
     1 '               identifier is m bytes long. '/
     1  /
     1 '     TYPE:  Match type. By default, sorting is done "verbatim',
     1                     '"')


         WRITE(6,  116)
  116 FORMAT(
     1 '            (on a byte by byte basis). This can be modified b',
     1                     'y specifying'/
     1 '            flags in the TYPE variable. Valid flags include: '/
     1 '               I  : Case insensitive sort '/
     1 '               S  : Strip leading and trailing spaces '/
     1 '              IS  : Case insensitive, and strip spaces '/
     1 '               M  : Many small records (60bx800k, default ',
     1                      ' is 200Kx256b)'/
     1 '               N  : Numeric sort '/)

         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif



         WRITE(6,  1161)
 1161 FORMAT(

     1 '             * Comment line delimiter. '/
     1 '               By default, lines in text files that begin wit',
     1                     'h a ;'/
     1 '               are assumed to be "comment lines".  You can ch',
     1                     'ange')


         WRITE(6,  118)
  118 FORMAT(
     1 '               this delimiter by adding a Dxyz after the I,S,',
     1                     'IS, or N.'/
     1 '               The xyz should be a list of "comment line" sig',
     1                     'nifers.'/
     1  /
     1 '               Examples:  D*@;  :the *, @, and ; characters '/
     1 '                                all signal "comment line" '/
     1 '                         ID*@;  : same as above, case Insensi',
     1                     'tive sort'/
     1 '                          D     : there are no "comment line"',
     1                     ' characters'/
     1 '                         ND     : same as above, numeric sort '/
     1  /
     1 '               Note that comment lines can only occur in "tex',
     1                     't input"')


         WRITE(6,  120)
  120 FORMAT(
     1 '               files -- fixed record input files are assumed ',
     1                     'to have'/
     1 '               no comment records! '/)


         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif
 

         WRITE(6,  1201)
 1201 FORMAT(//
     1 '    OUTOFF: # bytes offset to add to the start of the output ',
     1                     'file.'/
     1 '            This offset can be later filled (by other program',
     1                     's)'/
     1 '            with explanatory information.  In addition, if an '/
     1 '            offset>20 is used, a text string stating the numb',
     1                     'er of'/
     1 '            records, and the record size, is written into thi',
     1                     's space.'/
     1  /)

         WRITE(6,  122)
  122 FORMAT(
     1 '             OUTOFF is also used to specify the "text file mo',
     1                     'de".'/
     1 '             There are two text file modes that you can speci',
     1                     'fy:'/
     1 '                      outoff = -1 : text file output (record ',
     1                     '# & value'/
     1 '                      outoff = -2 : text file output, value o',
     1                     'nly'/
     1  /
     1 '   QUIET:    If set to 1, suppress status messages. '//
     1 ' Notes: ' )

         WRITE(6,  124)
  124 FORMAT(
     1 '    *  When a line in a text input file starts with a  semi c',
     1                     'olon,'/
     1 '       it is assumed to be a comment (and is ignored). '/
     1  /
     1 '    *  Reminder: to save results as a text file, set OUTOFF t',
     1                     'o -1 or -2.'/)


         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif
 

         WRITE(6,  1241)
 1241 FORMAT(
     1 '             A Note on the Structure of QSORT`s Output Files '/
     1  /
     1 ' QSORT writes two pieces of information per record: the sorte',
     1                     'd values')


         WRITE(6,  126)
  126 FORMAT(
     1 ' (of the identifier), and it`s record number in the original ',
     1                     'dataset (after'/
     1 ' discarding  comment lines and the input-file offset). When t',
     1                     'ext'/
     1 ' mode is selected (i.e.; by setting OUTOFF to -1), then this ',
     1                     'appears'/
     1 ' as a pair of space delimited values: the first being an inte',
     1                     'ger'/
     1 ' containing the record number, the second being the identifie',
     1                     'r`s value.'/
     1  /
     1 ' When text mode is not selected, a fixed length record file i',
     1                     's created.'/
     1 ' Each record contains the "original" record number in the fir',
     1                     'st four'/
     1 ' bytes of each fixed-length record, followed by the identifie',
     1                     'r`s value.'/
     1 ' These 4 bytes are to be read as binary integer. '/)



         if (dostop) then
            write(6,*) ' Hit ENTER to continue...'
            read(5,*)
         endif
 


         WRITE(6,  128)
  128 FORMAT(
     1  /
     1 ' For example, assume a 10 character record (that is, 6 charac',
     1                     'ters are used'/
     1 ' to store the identifier values), with results stored in a fi',
     1                     'le named'/
     1 ' RES.OUT. The following REXX programette will display the  ',
     1                     'value and '/
     1 ' "original" record number" of the first 100 entries . '/
     1  /
     1 '   alist=charin(`res.out`,1,1000)   /* read  first 1000 bytes',
     1                     ' of the file */'/
     1 '   do mm=1 to 100 '/
     1 '     iat=1+((mm-1)*10)               /*offset to start of rec',
     1                     'ord # mm */'/
     1 '     tmp1=substr(alist,iat,4)        /*get 4 byte "original" ',
     1                     'record # */')


         WRITE(6,  130)
  130 FORMAT(
     1 '     orignum=x2d(c2x(tmp1)          /* convert  to decimal nu',
     1                     'mber */'/
     1 '     thevalue=substr(alist,iat+4,6)     /* get 6 character "v',
     1                     'alue" */'/
     1 '      say " New record # " mm " is " thevalue " (original loc',
     1                     'ation= " orignum'/
     1 '   end '/
     1  /
     1 ' Needless to say, other languages may require different ',
     1                     'methods.  For example,'/
     1 ' with Watcom Fortran 9.0, you`ll need to reverse the order of',
     1                     ' the 4 bytes,'/
     1 ' and then use an internal write. '/
     1  /
     1  /)

         WRITE(6,  132)
  132 FORMAT(
     1  /
     1  )


         if (dostop) then
            write(6,*) ' Hit ENTER to exit...'
            read(5,*)
         endif
 


        return
        end


c00\0-======================
c show some help info
        subroutine show_help0
        PRINT *,' Sort a file.'
        print *,' Calling syntax: '
        print *,'  QSORT infil outfile inoff nrec recsiz start length ',
     2          ' type outoff q'

c Call as SORT1  INFILE  OUTFILE inoffset NRECS RECSIZE start length SORTTYPE offset quiet

          print *,' Where: '
          print *,'   Infil:  file to be sorted'
          print *,'   outfil: file to be created (containing ',
     1            ' sorted results'
          print *,'    inoff: input file offset (in records or lines'
          print *,'    nrec: # of records (0=program determines '
          print *,
     1       '   recsiz: size of record (in bytes), or 0=crlf '
          print *,
     1      '    start: start (or word) of id var (0=use whole record'
          print *,'    length: length of id var (ignored if start=0'
          print *,'     type: Sort type:S and/or I, or N '
          print *,
     1        '   outoff: Output file offset (space left empty at ',
     2        ' start of file'
          print *,'      q: Quiet -- if 1, suppress screen i/o'
        print *,' '
        print *,' Special: outoff=-1 : text file output (rec # & value'
        print *,'          outoff=-2 : text file output, value only'
         return
        end


c******************
c get info from command line
        SUBROUTINE GET_INFO_CMD(INCMD)
        CHARACTER *(*) INCMD

        character *240 inname,outname
        CHARACTER *20 kap
        CHARACTER *1 AA1
        integer offset
        character *60 bs(22)
        logical quiet,qlarge
        common /stuff/inname,outname,inoffset,irecs,ksize,klength,
     1                kstart,kap,offset,qlarge


         call parstrg(incmd,bs,10)
         inname=bs(1)
         outname=bs(2)

         inoffset=val(bs(3),ierr)
        if (ierr.gt.0) then
                   print *, ' bad input offset ',bs(3)
                   stop
        endif


        irecs=val(bs(4),ierr)
        if (ierr.gt.0) then
                   print *, ' bad # records ',bs(4)
                   stop
        endif

        ksize=val(bs(5),ierr)
        if (ierr.gt.0.or.ksize.lt.0)  then
                    print *,  ' bad # record size ',bs(5)
                    stop
        endif

        kstart=val(bs(6),ierr)
        if (ierr.gt.0.or.kstart.lt.0) then
                  print *,'bad start location ',bs(6)
                  stop
        endif
                
        klength=val(bs(7),ierr)
        if (ierr.gt.0.or.klength.lt.0) then
                 print *,' bad length ',bs(7)
                 stop
        endif

        IF (KSTART.GT.100.AND.KLENGTH.EQ.0) THEN
                 print *,' Word number must be <=100 ',kstart
                 stop
        endif


c sort type
        kap=bs(8)
        call strip(kap)

c offset
        if (bs(9).ne.' ') then
           offset=val(bs(9),ierr)
          if (offset.lt.0.or.ierr.gt.0) then
                print *,' Bad value for offset: ', bs(9)
                stop
          endif
       endif

c quiet?
       aa1=bs(10)
       if (index('Y12',aa1).gt.0) quiet=.true.

       if (.not.quiet) then
                write(6,91)inname(1:lentrim(inname)),
     1                     outname(1:lentrim(outname))
 91              format(' Sorting:',a/'    to:',a)
                 if (ksize.eq.0) then
                    print *,' One record per line '
                   print *,' # of lines  to offset: ',inoffset
                 else
                    print *,' Record size=',ksize
                    print *,' # of records to offset: ',inoffset
                 endif
                 print *,' Output offset (bytes): ',offset
                 if (klength.eq.0) then
                           print *,' Using word # ',kstart
                 else
                     print *,' Using start,finish: ',kstart,klength
                 endif
                 print *,'   Sort Type: ',kap
        endif


        RETURN
        END


c******************
c get info from user
c INname inoffset OUTname iRECS kSIZE kstart klength SORTTYPE offset quiet

        subroutine get_info
       

        character *240 inname,outname
        CHARACTER *20 kap
        character *132 ascird
        integer offset,qlarge

        common /stuff/inname,outname,inoffset,irecs,ksize,klength,
     1                kstart,kap,offset,qlarge

        print *,' QSORT: Indexed Quik Sort of a flat file '
        print *,' For more detailed help, enter QSORT ? from an ',
     1           ' OS/2 prompt'
        print *,' '
        print *,' Please sort parameters: '

       inname=ascird(' Enter input file name ')
       outname=ascird( ' Enter output file name ')
       if (inname.eq.' '.or.outname.eq.' ') then
                print *,' You must enter an input and output file name'
                goto 22
       endif


 22     CONTINUE
         ksize=valuerd(
     1      ' Enter input file record size (0=one line per record)')
             if (ksize.lt.0) then
                print *,' You must enter a non-negative record size '
                goto 22
        endif
 
 24     if (ksize.gt.0) then
            inoffset=valuerd(
     1           ' # records to offset from beginning of input file ')
         else
            inoffset=valuerd(
     1            ' # lines  to offset from beginning of input file ')
         endif
         offset=valuerd(' #bytes to offset in output file (or -1,-2): ')

         klength=0
         kstart=valuerd(
     1            '    identifier starts at (0=entire record): ')
         if (kstart.GT.0) then
                  klength=valuerd('     #bytes (0=use nth word): ')
         endif

 26     irecs=valuerd(' Enter #records (0=program determines) ')
        if (irecs.lt.0) then
                print *,' You must enter a non-negative # of records '
                goto 26
        endif

         kap=ascird(' Sort Types (L,I,S,N,Dxx): ')
         call strip(kap)
        return
        end



c==============================================================

c   SOrt to and index.  Index is integer, array to sort is real.
c Based on QUIKSORT

        SUBROUTINE INDEXSORT(X,xindex,nx)

        character *60 x(800000)
        character *60 pivotv
        integer    xindex(800000)
        integer stack(500)
        integer segbeg,segend,segsize,ep,bp,mid
         integer lenend,lenbeg,newpivot

        logical QPopSort

        nspt=0

c initialize stack

        do 2 ij=1,500
           stack(ij)=0
  2     continue

        do 3 ij=1,nx
           xindex(ij)=ij
 3      continue
        
        segbeg=1
        segend=nx

c  first "sort"
        call indqsort3(segbeg,mid,segend,pivotv,x,xindex)
        if (nx.le.3) goto 2000

 100    continue
        bp=segbeg
        ep=segend

 200    continue
        if (x(xindex(bp)).le.pivotv .and.bp.lt.segend) then
          bp=bp+1
          goto 200
        endif

 300    continue
        if (x(xindex(ep)).ge.pivotv.and.bp.gt.segbeg) then
            ep=ep-1
            goto 300
        endif

        if (ep.gt.bp) then
           call intswap(xindex(bp),xindex(ep))
           bp=bp+1
           ep=ep-1
           goto 200
        endif


        if (bp.gt.mid) then
          if (ep.gt.mid) then
              call intswap(xindex(ep),xindex(mid))
              newpivot=ep
          else
              newpivot=mid
          endif
        else
           call intswap(xindex(bp),xindex(mid))
           newpivot=bp
        endif

        lenend=segend-newpivot
        lenbeg=newpivot-segbeg

        if (lenend.gt.lenbeg) then
           call pushsort(newpivot+1,segend,stack,nspt)
           segend=newpivot-1
           segsize=lenbeg
        else
           call pushsort(segbeg,newpivot-1,stack,nspt)
           segbeg=newpivot+1
           segsize=lenend
        endif

        call indqsort3(segbeg,mid,segend,pivotv,x,xindex)

        if (segsize.gt.3) goto 100

 1000   continue
        if (.not.QPopSort(segbeg,segend,stack,nspt)) then
            goto 2000
        else
           segsize=segend-segbeg+1
           call indqsort3(segbeg,mid,segend,pivotv,x,xindex)
           if (segsize.le.3) then
             goto 1000
           else
             goto 100
           endif
        endif

 2000   continue
         return
        end





c--------
        subroutine indqsort3(segbeg,mid,segend,pivotv,x,xindex)

        character *60 x(800000),pivotv
        integer segbeg,mid,segend
        integer xindex(800000)

        mid=(segbeg+segend)/2
        if (segbeg+1.eq.segend) then
            if (x(xindex(segbeg)).gt.x(xindex(segend))) then
               call intswap(xindex(segbeg),xindex(segend))
            endif
            return
        endif

        if (x(xindex(segbeg)).gt.x(xindex(mid))) then
            if (x(xindex(segbeg)).gt.x(xindex(segend))) then
              call intswap(xindex(segbeg),xindex(segend))
              if (x(xindex(segbeg)).gt.x(xindex(mid))) then
                call intswap(xindex(segbeg),xindex(mid))
              endif
            else
              call intswap(xindex(segbeg),xindex(mid))
            endif
        else
            if (x(xindex(mid)).gt.x(xindex(segend))) then
               call intswap(xindex(mid),xindex(segend))
               if (x(xindex(segbeg)).gt.x(xindex(mid))) then
                 call intswap(xindex(segbeg),xindex(mid))
               endif
            else
               continue
            endif
        endif

        pivotv=x(xindex(mid))
        return
        end



c==============================================================

c   SOrt to and index (240 byte records).  Index is integer, array to sort is real.
c Based on QUIKSORT

        SUBROUTINE INDEXSORTb(X,xindex,nx)

        character *240 x(200000)
        character *240 pivotv
        integer    xindex(200000)
        integer stack(500)
        integer segbeg,segend,segsize,ep,bp,mid
         integer lenend,lenbeg,newpivot

        logical QPopSort

        nspt=0

c initialize stack

        do 2 ij=1,500
           stack(ij)=0
  2     continue

        do 3 ij=1,nx
           xindex(ij)=ij
 3      continue
        
        segbeg=1
        segend=nx

c  first "sort"
        call indqsort3b(segbeg,mid,segend,pivotv,x,xindex)
        if (nx.le.3) goto 2000

 100    continue
        bp=segbeg
        ep=segend

 200    continue

        if (x(xindex(bp)).le.pivotv .and.bp.lt.segend) then
          bp=bp+1
          goto 200
        endif

 300    continue
        if (x(xindex(ep)).ge.pivotv.and.bp.gt.segbeg) then
            ep=ep-1
            goto 300
        endif
        if (ep.gt.bp) then
           call intswap(xindex(bp),xindex(ep))
           bp=bp+1
           ep=ep-1
           goto 200
        endif


        if (bp.gt.mid) then
          if (ep.gt.mid) then
              call intswap(xindex(ep),xindex(mid))
              newpivot=ep
          else
              newpivot=mid
          endif
        else
           call intswap(xindex(bp),xindex(mid))
           newpivot=bp
        endif

        lenend=segend-newpivot
        lenbeg=newpivot-segbeg

        if (lenend.gt.lenbeg) then
           call pushsort(newpivot+1,segend,stack,nspt)
           segend=newpivot-1
           segsize=lenbeg
        else
           call pushsort(segbeg,newpivot-1,stack,nspt)
           segbeg=newpivot+1
           segsize=lenend
        endif

        call indqsort3b(segbeg,mid,segend,pivotv,x,xindex)

        if (segsize.gt.3) goto 100

 1000   continue
        if (.not.QPopSort(segbeg,segend,stack,nspt)) then
            goto 2000
        else
           segsize=segend-segbeg+1
           call indqsort3b(segbeg,mid,segend,pivotv,x,xindex)
           if (segsize.le.3) then
             goto 1000
           else
             goto 100
           endif
        endif

 2000   continue
         return
        end





c--------
        subroutine indqsort3b(segbeg,mid,segend,pivotv,x,xindex)

        character *240 x(200000),pivotv
        integer segbeg,mid,segend
        integer xindex(200000)

        mid=(segbeg+segend)/2
        if (segbeg+1.eq.segend) then
            if (x(xindex(segbeg)).gt.x(xindex(segend))) then
               call intswap(xindex(segbeg),xindex(segend))
            endif
            return
        endif

        if (x(xindex(segbeg)).gt.x(xindex(mid))) then
            if (x(xindex(segbeg)).gt.x(xindex(segend))) then
              call intswap(xindex(segbeg),xindex(segend))
              if (x(xindex(segbeg)).gt.x(xindex(mid))) then
                call intswap(xindex(segbeg),xindex(mid))
              endif
            else
              call intswap(xindex(segbeg),xindex(mid))
            endif
        else
            if (x(xindex(mid)).gt.x(xindex(segend))) then
               call intswap(xindex(mid),xindex(segend))
               if (x(xindex(segbeg)).gt.x(xindex(mid))) then
                 call intswap(xindex(segbeg),xindex(mid))
               endif
            else
               continue
            endif
        endif

        pivotv=x(xindex(mid))
        return
        end





c==============================================================

c   SOrt to and index.  Index is integer, array to sort is real.
c Based on QUIKSORT

        SUBROUTINE nINDEXSORT(Xc,x,xindex,nx)

        character *60 xc(800000)
        real *8 x(800000)
        real *8 pivotv
        integer    xindex(800000)
        integer stack(500)
        integer segbeg,segend,segsize,ep,bp,mid
         integer lenend,lenbeg,newpivot

        logical QPopSort

        nspt=0

c initialize stack

        do 2 ij=1,500
           stack(ij)=0
  2     continue

        do 3 ij=1,nx
           xindex(ij)=ij
           x(ij)=val(xc(ij),ierr)
           if (ierr.gt.0) then
                print *,' ERROR. Non Numeric at line ',ij,' = ',xc(ij)
                stop
           endif
 3      continue
        
        segbeg=1
        segend=nx

c  first "sort"
        call nindqsort3(segbeg,mid,segend,pivotv,x,xindex)
        if (nx.le.3) goto 2000

 100    continue
        bp=segbeg
        ep=segend

 200    continue
        if (x(xindex(bp)).le.pivotv .and.bp.lt.segend) then
          bp=bp+1
          goto 200
        endif

 300    continue
        if (x(xindex(ep)).ge.pivotv.and.bp.gt.segbeg) then
            ep=ep-1
            goto 300
        endif

        if (ep.gt.bp) then
           call intswap(xindex(bp),xindex(ep))
           bp=bp+1
           ep=ep-1
           goto 200
        endif


        if (bp.gt.mid) then
          if (ep.gt.mid) then
              call intswap(xindex(ep),xindex(mid))
              newpivot=ep
          else
              newpivot=mid
          endif
        else
           call intswap(xindex(bp),xindex(mid))
           newpivot=bp
        endif

        lenend=segend-newpivot
        lenbeg=newpivot-segbeg

        if (lenend.gt.lenbeg) then
           call pushsort(newpivot+1,segend,stack,nspt)
           segend=newpivot-1
           segsize=lenbeg
        else
           call pushsort(segbeg,newpivot-1,stack,nspt)
           segbeg=newpivot+1
           segsize=lenend
        endif

        call nindqsort3(segbeg,mid,segend,pivotv,x,xindex)

        if (segsize.gt.3) goto 100

 1000   continue
        if (.not.QPopSort(segbeg,segend,stack,nspt)) then
            goto 2000
        else
           segsize=segend-segbeg+1
           call nindqsort3(segbeg,mid,segend,pivotv,x,xindex)
           if (segsize.le.3) then
             goto 1000
           else
             goto 100
           endif
        endif

 2000   continue
         return
        end





c--------
        subroutine nindqsort3(segbeg,mid,segend,pivotv,x,xindex)

        real *8 x(800000),pivotv
        integer segbeg,mid,segend
        integer xindex(800000)

        mid=(segbeg+segend)/2
        if (segbeg+1.eq.segend) then
            if (x(xindex(segbeg)).gt.x(xindex(segend))) then
               call intswap(xindex(segbeg),xindex(segend))
            endif
            return
        endif

        if (x(xindex(segbeg)).gt.x(xindex(mid))) then
            if (x(xindex(segbeg)).gt.x(xindex(segend))) then
              call intswap(xindex(segbeg),xindex(segend))
              if (x(xindex(segbeg)).gt.x(xindex(mid))) then
                call intswap(xindex(segbeg),xindex(mid))
              endif
            else
              call intswap(xindex(segbeg),xindex(mid))
            endif
        else
            if (x(xindex(mid)).gt.x(xindex(segend))) then
               call intswap(xindex(mid),xindex(segend))
               if (x(xindex(segbeg)).gt.x(xindex(mid))) then
                 call intswap(xindex(segbeg),xindex(mid))
               endif
            else
               continue
            endif
        endif

        pivotv=x(xindex(mid))
        return
        end





c------------------
c given a sorted list,vals of len nvals, will find location
c in list with value = to target (or closest value < target)

        integer function isearch (vals,nvals,target)

        real vals(nvals)

        ib=1
        ie=nvals
        if (target.le.vals(ib)) then
            isearch=0
            return
        else if (target.ge.vals(ie)) then
            isearch=ie
            return
        endif

 100    continue
        len=ie-ib+1
        if (len.le.2) then
           if (vals(ie).le.target) then
               isearch=ie
           else
               isearch=ib
           endif
           return
        endif

        imid=ib+(len/2)

        if (vals(imid).eq.target) then
            isearch=imid
            return
        else if (vals(imid).lt.target) then
            ib=imid
        else
            ie=imid
        endif

        goto 100

        end


        subroutine pushsort(sb,se,stack,stackct)
        integer se,sb,stack(1),stackct


        if (stackct+2.gt.500) then
           print *,' % Error in QUIKSORT: ARRAY TOO LONG '
           stop 0
        endif

        stackct=stackct+1
        stack(stackct)=sb

        stackct=stackct+1
        stack(stackct)=se

        return
        end


        logical function QPopSort(sb,se,stack,stkpoint)
        integer sb,se,stack(1),stkpoint

        if (stkpoint-1.le.0)then
           qpopsort=.false.
           return
        endif

        se=stack(stkpoint)
        stkpoint=stkpoint-1
        sb=stack(stkpoint)
        stkpoint=stkpoint-1
        qpopsort =.true.
        return
        end


        subroutine swap(x,y)
        character *(*) x,y
        character *240 t
        ii=len(x)
        t=x
        x=y
        y=t
        return
        end

        subroutine intswap(ix,iy)
        it=ix
        ix=iy
        iy=it
        return
        end


        character *(*) function ascird(Prompt)

        character *(*) prompt
        CHARACTER *80 ANS

 42     Write(6,44)prompt
 44     format(' ',a,'?'\)

 10     read(5,45)ANS
 45     FORMAT(A80)

        if (ichar(ans).eq.5) then
           pause ' Temporary exit to DOS: Enter 1 DOS command.'
           goto 42
        endif

        ascird=ans
        return
        end


C---------
C  GENERAL READ VALUE FUNCTION -- WITH ERROR TRAPPING,ETC.


        real    function valuerd(amess)
        character *(*) amess
        CHARACTER *40 ANS

 42       Write(6,44)AMESS
 44     format(' ',a,'?'\)


 10     read(5,45)ANS
 45     FORMAT(A40)

        if (ichar(ans).eq.5) then
           pause ' Temporary exit to DOS: Enter 1 DOS command.'
           goto 42
        endif

        TT=VAL(ANS,IERR)
        IF (IERR.GT.0) THEN
            WRITE(6,66)
 66     FORMAT('$ %BAD INPUT -- REENTER :: ')
            GOTO 10
        ENDIF
        VALUERD=TT
        RETURN
        END

C---------------------------
C --- GIVEN A STRING, RETURNS REAL NUMBER VALUE, OR SETS ERROR FLAG

        REAL FUNCTION VAL(ANS,IERR)

        CHARACTER *(*) ANS

        IERR=0

        IF (ANS.EQ.' ')THEN
           VAL=0.0
           RETURN
        ELSEIF (ANS.EQ.'PI'.OR.ANS.EQ.'pi') THEN
           VAL=3.1415926
           RETURN
        ELSEIF (ANS.EQ.'E'.OR.ANS.EQ.'e') THEN
           VAL=2.718212
           RETURN
        ENDIF
        IF (INDEX(ANS,'.').GT.0) THEN
           READ(ANS,66,ERR=200)VV
 66        format(f16.5)
           val=vv
           return
        ELSE
           READ(ANS,77,ERR=200)IV
 77        FORMAT(I12)
           VAL=IV
           RETURN
        ENDIF

 200    CONTINUE
        IERR=1
        RETURN

        END


c--------------
c routine to return discrete blocks of characters, as seperated
c by tabs, spaces, commas.
c NOTE:: array to be constucted (eg; bs) must by *25 (stupid compiler
c                                               messes up if *(*) is used)

        subroutine parstrg2(strg,bs,nvals)

        character *240    bs(1)
        character *(*) strg
        character *240 ablock
        CHARACTER *1 ACHAR

        DATA ICOMMA,ISPACE,ITAB/44,32,9/

C SCAN FROM CHAR 1 TO CHAR ILEN, CONTIGUOUS CHARACTERS WILL BE grouped
c togethter into discrete words

        ilenb=len(bs(1))
        ilen=len(strg)

        DO 100 IJ=1,nvals
           bs  (IJ)=' '
 100    CONTINUE

        if (strg.eq.' '.or.ilen.eq.0) return


        NTHCHAR=0
        KURVAL=1

 200    CONTINUE

        IF (KURVAL.GT.NVALS) RETURN

        CALL EATSPC(STRG,NTHCHAR,ILEN)

        IF (NTHCHAR.GT.ILEN) RETURN

        ACHAR=STRG(NTHCHAR:NTHCHAR)
        IC=ICHAR(ACHAR)
        IF (IC.EQ.ICOMMA) THEN
           KURVAL=KURVAL+1
           GOTO 200
        ENDIF

c else, a character :: so start building a "block"

          ibb=1
          ablock=' '
          ablock(ibb:ibb)=achar

C       check to see if at last character of string
          IF (NthCHAR.EQ.ILEN) THEN
                GOTO 400
          ENDIF

c more possible characters-- read them in
          itmp=NTHCHAR+1
          do 230 iii=itmp,ilen
             NTHCHAR=iii
             achar=strg(NTHCHAR:NTHCHAR)
             ic=ICHAR(ACHAR)
             if (IC.EQ.ISPACE.OR.IC.EQ.ICOMMA.OR.IC.eq.ITAB) THEN
C END OF BLOCK
                 goto 400
             else
                ibb=ibb+1
                if (ibb.le.240) then
                   ablock(ibb:ibb)=achar
                endif
             endif
 230      continue

 400      continue
          bs(kurval)=ablock
          kurval=kurval+1

c now, eat up intervening spaces and tabs
          if (ic.eq.icomma) goto 200

          CALL EATSPC(STRG,NTHCHAR,ILEN)

C if no comma between numbers, then next non space is start of next number
c so, dont skip over it (reduce nthchar )

          if (nthchar.gt.ilen) return

          IF (STRG(NTHCHAR:NTHCHAR).ne.',') NTHCHAR=NTHCHAR-1
          goto 200

        END

c--------------
c routine to return discrete blocks of characters, as seperated
c by tabs, spaces, commas.
c NOTE:: array to be constucted (eg; bs) must by *25 (stupid compiler
c                                               messes up if *(*) is used)

        subroutine parstrg(strg,bs,nvals)

        character *60    bs(1)
        character *(*) strg
        character *60 ablock
        CHARACTER *1 ACHAR

        DATA ICOMMA,ISPACE,ITAB/44,32,9/

C SCAN FROM CHAR 1 TO CHAR ILEN, CONTIGUOUS CHARACTERS WILL BE grouped
c togethter into discrete words

        ilenb=len(bs(1))
        ilen=len(strg)

        DO 100 IJ=1,nvals
           bs  (IJ)=' '
 100    CONTINUE

        if (strg.eq.' '.or.ilen.eq.0) return


        NTHCHAR=0
        KURVAL=1

 200    CONTINUE

        IF (KURVAL.GT.NVALS) RETURN

        CALL EATSPC(STRG,NTHCHAR,ILEN)

        IF (NTHCHAR.GT.ILEN) RETURN

        ACHAR=STRG(NTHCHAR:NTHCHAR)
        IC=ICHAR(ACHAR)
        IF (IC.EQ.ICOMMA) THEN
           KURVAL=KURVAL+1
           GOTO 200
        ENDIF

c else, a character :: so start building a "block"

          ibb=1
          ablock=' '
          ablock(ibb:ibb)=achar

C       check to see if at last character of string
          IF (NthCHAR.EQ.ILEN) THEN
                GOTO 400
          ENDIF

c more possible characters-- read them in
          itmp=NTHCHAR+1
          do 230 iii=itmp,ilen
             NTHCHAR=iii
             achar=strg(NTHCHAR:NTHCHAR)
             ic=ICHAR(ACHAR)
             if (IC.EQ.ISPACE.OR.IC.EQ.ICOMMA.OR.IC.eq.ITAB) THEN
C END OF BLOCK
                 goto 400
             else
                ibb=ibb+1
                if (ibb.le.60) then
                   ablock(ibb:ibb)=achar
                endif
             endif
 230      continue

 400      continue
          bs(kurval)=ablock
          kurval=kurval+1

c now, eat up intervening spaces and tabs
          if (ic.eq.icomma) goto 200

          CALL EATSPC(STRG,NTHCHAR,ILEN)

C if no comma between numbers, then next non space is start of next number
c so, dont skip over it (reduce nthchar )

          if (nthchar.gt.ilen) return

          IF (STRG(NTHCHAR:NTHCHAR).ne.',') NTHCHAR=NTHCHAR-1
          goto 200

        END


C------------
C ROUTINE TO LOOK FOR FIRST NON TAB/SPACE CHARACTER,, AFTER
C POSITION NPOS . RETURNS LOCATION OF THIS NON TAB/SPACE CHAR.

      SUBROUTINE EATSPC(ASTRG,NPOS,NLEN)

      CHARACTER *(*)ASTRG
      CHARACTER *1 ACHAR
        DATA ISPACE,ITAB/32,9/

      IF (NPOS.ge.NLEN) THEN
         NPOS=NLEN+1
         RETURN
      ENDIF

      IS=NPOS+1
      DO 100 IJ=IS,NLEN
         ACHAR=ASTRG(IJ:IJ)
         IC=ICHAR(ACHAR)
         IF (IC.EQ.ISPACE.OR.IC.EQ.ITAB) THEN
            CONTINUE
         ELSE
            NPOS=IJ
            RETURN
         ENDIF
 100  CONTINUE

      NPOS=NLEN+1
      RETURN
      END

c-------------------------

        subroutine captaliz(sent)

        character *(*)sent
        character *1 char


 10      do 100 ij=1,len(sent)
            let=ichar(sent(ij:IJ))
            if (let.ge.97.and.let.le.122) sent(ij:ij)=char(let-32)
 100    continue
        return
        end



        subroutine strip(astring0)
        character *(*)astring0
        CHARACTER *200 ASTRING
        MM2=1
        ASTRING=ASTRING0
        do mm=1,Lentrim(astring)
            if (astring(mm:mm).ne.' ' ) exit
            mm2=mm2+1
        endDO
        if (mm2.le.lentrim(astring)) then
              astring0=astring(mm2:lentrim(astring))
        endif

        return
        end
                          
